{% extends "codex_app/base.html" %}
{% block title %}{{term.name}} — term{% endblock title %}
{% block style %}
#wrapper {
max-width: 44em;
margin-left: 3em;
}
.image-annotation-list {
display: flex;
flex-wrap: wrap;
}
.image-annotation-list .image-item {
width: 256px;
margin: 1em;
flex-shrink: 0;
}
.image-list .image-item img {
width: 100%;
}

.text-item{
margin: 6em 0;
}

.par-order {
float: left;
width: 2em;
font-size: 80%;
font-style: italic;
margin-left: -2em;
color: #5e5e5e;
}

.block {
/* color:rgb(83, 83, 83); */
color:rgb(126, 126, 126);
}
.block.code {
color:black;
/* font-weight: bold; */
}
.text-content:hover .block.code {
/* font-weight: bold; */
color:rgb(0, 24, 61);
}
.text-content:hover .block {
/* font-weight: bold; */
color:rgb(190, 190, 190);
}
{% endblock %}

{% block content %}
<div id="wrapper">
    <h1>{{term.name}}</h1>
    <div class="statement">{{term.statement}}</div>

    <h2>images</h2>
    <div class="image-list">
        {% for a in images%}
        <h3><a href="{% url 'get_image' a.image.id %}">{{a.image.name}}</a></h3>
        <div class="image-annotation-list">
            {% for ia in a.annotations %}
            <div class="image-item">
                <img class="annotation" src="{% url 'codex:get_img_annotation_image' ia.id %}" />
            </div>
            {% endfor %}
        </div>
        {% endfor %}
    </div>


    {% comment %} <h2>texts</h2> {% endcomment %}
    {% for item in texts%}
    <div class="text-item">
        <h3>
            <a href="{% url 'get_text' item.text.id %}">{{item.text.title}}</a>
        </h3>
        number of codes: {{item.count}}
        {% for p in item.paragraphs %}

        <p>
        <div class="par-order">{{p.par.order}}</div>
        <div class="text-content"
            data-intervals="[{% for a in p.annotations %}[{{a.start}},{{a.end}}]{%if not forloop.last %},{%endif%}{% endfor %}]"
            data-content="{{p.par.clean_content|escapejs}}">{{p.par.clean_content}}</div>
        </p>
        {% endfor %}
    </div>
    {% endfor %}


    <h2>source</h2>
    {% for rel in source %}
    <div class="rel">
        <a class="source" href="{% url 'get_term' rel.source.id %}">{{rel.source.name}}</a>
        ↪
        <a class="dest" href="{% url 'get_term' rel.destination.id %}">{{rel.destination.name}}</a>
        <a class="kind" href="{% url 'get_term' rel.kind.id %}">[{{rel.kind.name}}]</a>
    </div>
    {% endfor %}

    <h2>destination</h2>
    {% for rel in destination %}
    <div class="rel">
        <a class="source" href="{% url 'get_term' rel.source.id %}">{{rel.source.name}}</a>
        ↪
        <a class="dest" href="{% url 'get_term' rel.destination.id %}">{{rel.destination.name}}</a>
        <a class="kind" href="{% url 'get_term' rel.kind.id %}">[{{rel.kind.name}}]</a>
    </div>
    {% endfor %}
</div>
{% endblock %}

{% block script %}


function emptyElement(elem) {
while (elem.firstChild) {
removeElement(elem.firstChild);
}
return elem;
}

function removeElement(elem, keepChildren = false) {
if (!keepChildren) {
emptyElement(elem);
}
const parent = elem.parentNode;
if (parent) {
parent.removeChild(elem);
}
}


const sortInterval = (a,b) => a[0] - b[0]

const sortIntervals = (is) => is.sort(sortInterval)

const compileAnnotations = (content, rawIntervals) => {
const start = 0;
const end = content.length;
const intervals = [
...new Set(
sortIntervals(rawIntervals).reduce(
(acc, i) => acc.concat(i[0], i[1]),
[start, end]
)
),
].sort((a, b) => a - b);

const inInterval = (left, right) => rawIntervals.filter(
(a) => a[0] < right && a[1]> left
    ).length > 0;

    const blocks= [];
    for (let i = 1; i < intervals.length; i +=1) { blocks.push({ start: intervals[i - 1], end: intervals[i], content:
        content.slice(intervals[i - 1], intervals[i]), isCode: inInterval(intervals[i - 1], intervals[i]) }); } return
        blocks; } const highlightCode=(elem)=> {
        const intervals = JSON.parse(elem.getAttribute('data-intervals'))
        const content = JSON.parse('"' + elem.getAttribute('data-content') + '"')
        {% comment %} const content = elem.textContent {% endcomment %}
        const blocks = compileAnnotations(content, intervals)
        emptyElement(elem)
        blocks.forEach(block => {
        const className = `block ${block.isCode ? 'code' : ''}`
        const span = document.createElement('span')
        const text = document.createTextNode(block.content)
        span.setAttribute('class', className)
        span.appendChild(text)
        elem.appendChild(span)
        })
        }

        document.querySelectorAll('.text-content').forEach(highlightCode)
        // document.querySelectorAll('.text-content').forEach((elem, i) => {
        // setTimeout(() => highlightCode(elem), i * 600)
        // })

        {% endblock %}